﻿using Syncfusion.XlsIO;
using System;
using System.Collections.Generic;
using System.IO;

namespace SyncFusionExcel
{
    class Program
    {
        static void Main(string[] args)
        {
            var data = new List<ProductCluster>
            {
                new ProductCluster
                {
                    Id = 1,
                    Name = "CL1",
                    Products = new List<Product>
                    {
                        new Product { Id = 1, Name = "Prod 1"},
                        new Product { Id = 2, Name = "Prod 2"},
                        new Product { Id = 3, Name = "Prod 3"},
                        new Product { Id = 4, Name = "Prod 4"},
                    }
                },
                new ProductCluster
                {
                    Id = 2,
                    Name = "CL2",
                    Products = new List<Product>
                    {
                        new Product { Id = 5, Name = "Prod 5"},
                    }
                },
                new ProductCluster
                {
                    Id = 3,
                    Name = "CL3",
                    Products = new List<Product>
                    {
                        new Product { Id = 6, Name = "Prod 6"},
                        new Product { Id = 7, Name = "Prod 7"},
                        new Product { Id = 8, Name = "Prod 8"},
                        new Product { Id = 9, Name = "Prod 9"},
                        new Product { Id = 10, Name = "Prod 10"},
                        new Product { Id = 11, Name = "Prod 11"},
                        new Product { Id = 12, Name = "Prod 12"},
                    }
                },
                new ProductCluster
                {
                    Id = 4,
                    Name = "CL4",
                    Products = new List<Product>
                    {
                        new Product { Id = 13, Name = "Prod 13"},
                        new Product { Id = 14, Name = "Prod 14"},
                        new Product { Id = 15, Name = "Prod 15"},
                        new Product { Id = 16, Name = "Prod 16"},
                        new Product { Id = 17, Name = "Prod 17"},
                        new Product { Id = 18, Name = "Prod 18"},
                        new Product { Id = 19, Name = "Prod 19"},
                        new Product { Id = 20, Name = "Prod 20"},
                    }
                }
            };

            using (ExcelEngine excelEngine = new ExcelEngine())
            using (var templateStream = File.OpenRead("DataTemplate.xlsx"))
            using (var outputStream = File.OpenWrite("Output.xlsx"))
            {
                IApplication application = excelEngine.Excel;
                application.DefaultVersion = ExcelVersion.Excel2013;
                IWorkbook workbook = application.Workbooks.Open(templateStream);

                //Adding text to a cell
                ITemplateMarkersProcessor marker = workbook.CreateTemplateMarkersProcessor();
                marker.AddVariable("ProdClusters", data);

                marker.ApplyMarkers();

                //Saving the workbook to disk in XLSX format
                workbook.SaveAs(outputStream);
            }
        }
    }
}
